﻿SystemOrganization addCategory: #'Nagare-Squeak-Core'!

NgPortableUtil subclass: #NgSqPortableUtil
	instanceVariableNames: 'socketStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Squeak-Core'!

!NgSqPortableUtil class methodsFor: 'shutdown' stamp: 'mu 5/2/2012 16:10'!
shutDown: quitting
	quitting ifTrue: [self release].! !

!NgSqPortableUtil methodsFor: 'converting' stamp: 'mu 5/2/2012 15:58'!
asRecord: anObject
	anObject class = Association ifTrue: [^ self dictionaryFromAssociations: (Array with: anObject)].
	(anObject class = Array and: [anObject notEmpty and: [(anObject at: 1) class = Association]])
		ifTrue: [^ self dictionaryFromAssociations: anObject].
	^anObject! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:42'!
ensuredSocketStream
	self socketStream isNil ifTrue: [self prepareSocketStream].
	self socketStream isConnected ifFalse: [self releaseSocketStream].
	^self socketStream! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 13:54'!
hearbeatTo: host port: port
	| udpSock |
	udpSock := Socket newUDP.
	udpSock sendData: '' toHost: host port: port! !

!NgSqPortableUtil methodsFor: 'shutdown' stamp: 'mu 5/2/2012 14:00'!
listenSystemShutdownEvent
	SmalltalkImage current addToShutDownList: self class! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 14:37'!
prepareSocketStream
	| str |
	str := SocketStream openConnectionToHostNamed: self settings host port: self settings port.
	
	self socketStream: str! !

!NgSqPortableUtil methodsFor: 'initialize-release' stamp: 'mu 5/2/2012 14:48'!
release
	self releaseSocketStream.
	super release
	! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 14:38'!
releaseSocketStream
	self socketStream ifNil: [^self].
	self socketStream close.
	self socketStream: nil! !

!NgSqPortableUtil methodsFor: 'sending' stamp: 'mu 5/2/2012 23:59'!
sendBytes: bytes
	[self ensuredSocketStream nextPutAllFlush: bytes] on: NetworkError do: [:ex |
		(NgNetworkError originalError: ex) signal
	]! !

!NgSqPortableUtil methodsFor: 'converting' stamp: 'mu 5/2/2012 17:06'!
shortStackStringFrom: anException 
	| ctx stackString |
	ctx := anException signalerContext.
	stackString := ctx isNil
				ifTrue: ['']
				ifFalse: [String
						streamContents: [:strm | (ctx stackOfSize: 20)
								do: [:item | strm print: item. strm nextPutAll: '\'. 
										 ]]].
	^ stackString! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:13'!
socketStream
	"Answer the value of socketStream"

	^ socketStream! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:13'!
socketStream: anObject
	"Set the value of socketStream"

	socketStream := anObject! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:29'!
unixTimeSeconds
	^ TimeStamp current asUnixTime! !
